
#include "validator.bi"

#define USE_PCRE
#include "match.bas"
#include "split.bas"

function N(byval s as string) as integer
  dim as integer i, result = 0
  for i = 0 to len(s) - 1
    if instr("BKNPQRbknpqr", chr(s[i])) then
      result += 1
    else
      result += s[i] - asc("0")
    end if
  next i
  return result
end function

function IsFEN(byval s as string) as integer export
  
  const RE_WHITEKING = "K"
  const RE_BLACKKING = "k"
  const RE_PIECES = "^[1-8BKNPQRbknpqr]+$"
  const RE_ACTIVECOLOR = "^[wb]$"
  const RE_CASTLING = "^[KQkq]+$|^\-$"
  const RE_ENPASSANT = "^[a-h][36]$|^\-$"
  const RE_HALFMOVE = "^\d+$"
  const RE_FULLMOVE = "^[1-9]\d*$"
  
  redim as string a(), b()
  dim as integer i, result
  
  Split(s, " ", a())
  
  result = (ubound(a) = 6)
  
  if result then
    Split(a(1), "/", b())
    result = result and (ubound(b) = 8)
  end if
  
  if result then
    result = result and IsMatch(RE_WHITEKING, a(1))
    result = result and IsMatch(RE_BLACKKING, a(1))
    for i = lbound(b) to ubound(b)
      result = result and IsMatch(RE_PIECES, b(i)) and (N(b(i)) = 8)
    next i
    result = result and IsMatch(RE_ACTIVECOLOR, a(2))
    result = result and IsMatch(RE_CASTLING,    a(3))
    result = result and IsMatch(RE_ENPASSANT,   a(4))
    result = result and IsMatch(RE_HALFMOVE,    a(5))
    result = result and IsMatch(RE_FULLMOVE,    a(6))
  end if
  
  return result
end function
